blob: 3f08261e6b544eb4e09fe64c23da6c23e5f19d28 [file] [log] [blame]
Peter Stuge09377b72011-08-21 06:24:55 +02001#!/bin/sh
Stefan Reinauer074d9132009-09-26 16:43:17 +00002#
Stefan Reinauer5f1ad892010-05-17 11:02:25 +00003# Copyright (C) 2008-2010 by coresystems GmbH
Stefan Reinauer074d9132009-09-26 16:43:17 +00004# written by Patrick Georgi <patrick.georgi@coresystems.de> and
5# Stefan Reinauer <stefan.reinauer@coresystems.de>
Stefan Reinauer14e22772010-04-27 06:56:47 +00006#
Marc Jones2aac3f62011-08-08 16:07:50 -06007# Copyright (C) 2011 by Sage Electronic Engineering
8#
Stefan Reinauer074d9132009-09-26 16:43:17 +00009# This program is free software; you can redistribute it and/or modify
10# it under the terms of the GNU General Public License as published by
11# the Free Software Foundation; version 2 of the License.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
18# You should have received a copy of the GNU General Public License
19# along with this program; if not, write to the Free Software
Patrick Georgib890a122015-03-26 15:17:45 +010020# Foundation, Inc.
Stefan Reinauer074d9132009-09-26 16:43:17 +000021#
22
Patrick Georgi8135dba2015-03-17 21:05:20 +010023cd `dirname $0`
24
Stefan Reinauer14ce2132015-06-05 13:01:13 -070025CROSSGCC_DATE="June 4th, 2015"
26CROSSGCC_VERSION="1.29"
Stefan Reinauer074d9132009-09-26 16:43:17 +000027
28# default settings
29TARGETDIR=`pwd`/xgcc
30TARGETARCH=i386-elf
31DESTDIR=
32
Stefan Reinauer699ac272015-06-05 12:43:28 -070033# GCC toolchain version numbers
Patrick Georgi53c388f2015-03-07 09:55:18 +010034GMP_VERSION=6.0.0
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070035MPFR_VERSION=3.1.2
Paul Menzele6619422015-02-23 10:33:59 +010036MPC_VERSION=1.0.3
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000037LIBELF_VERSION=0.8.13
Patrick Georgi53c388f2015-03-07 09:55:18 +010038GCC_VERSION=4.9.2
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070039GCC_AUTOCONF_VERSION=2.69
Patrick Georgi53c388f2015-03-07 09:55:18 +010040BINUTILS_VERSION=2.25
41GDB_VERSION=7.9
42IASL_VERSION=20150204
43PYTHON_VERSION=3.4.3
Idwer Vollering296a0152012-10-26 01:48:04 +020044EXPAT_VERSION=2.1.0
Stefan Reinauer14ce2132015-06-05 13:01:13 -070045# CLANG version number
46CLANG_VERSION=3.6.1
Stefan Reinauer074d9132009-09-26 16:43:17 +000047
Stefan Reinauer699ac272015-06-05 12:43:28 -070048# GCC toolchain archive locations
Patrick Georgi53c388f2015-03-07 09:55:18 +010049GMP_ARCHIVE="http://ftpmirror.gnu.org/gmp/gmp-${GMP_VERSION}a.tar.bz2"
Patrick Georgi6e61ad32012-05-12 23:19:30 +020050MPFR_ARCHIVE="http://ftpmirror.gnu.org/mpfr/mpfr-${MPFR_VERSION}.tar.bz2"
Idwer Vollering7962fc72012-10-25 02:14:09 +020051MPC_ARCHIVE="http://ftpmirror.gnu.org/mpc/mpc-${MPC_VERSION}.tar.gz"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000052LIBELF_ARCHIVE="http://www.mr511.de/software/libelf-${LIBELF_VERSION}.tar.gz"
Idwer Vollering1cfee0b2012-10-25 02:03:53 +020053GCC_ARCHIVE="http://ftpmirror.gnu.org/gcc/gcc-${GCC_VERSION}/gcc-${GCC_VERSION}.tar.bz2"
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070054BINUTILS_ARCHIVE="http://ftpmirror.gnu.org/binutils/binutils-${BINUTILS_VERSION}.tar.bz2"
Patrick Georgi53c388f2015-03-07 09:55:18 +010055GDB_ARCHIVE="http://ftpmirror.gnu.org/gdb/gdb-${GDB_VERSION}.tar.xz"
56IASL_ARCHIVE="https://acpica.org/sites/acpica/files/acpica-unix-${IASL_VERSION}.tar.gz"
57PYTHON_ARCHIVE="http://www.python.org/ftp/python/${PYTHON_VERSION}/Python-${PYTHON_VERSION}.tar.xz"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010058EXPAT_ARCHIVE="http://downloads.sourceforge.net/sourceforge/expat/expat-${EXPAT_VERSION}.tar.gz"
Stefan Reinauer14ce2132015-06-05 13:01:13 -070059# CLANG toolchain archive locations
60LLVM_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/llvm-${CLANG_VERSION}.src.tar.xz"
61CFE_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/cfe-${CLANG_VERSION}.src.tar.xz"
62CRT_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/compiler-rt-${CLANG_VERSION}.src.tar.xz"
63CTE_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/clang-tools-extra-${CLANG_VERSION}.src.tar.xz"
Stefan Reinauer074d9132009-09-26 16:43:17 +000064
Stefan Reinauer699ac272015-06-05 12:43:28 -070065# GCC toolchain directories
Stefan Reinauer074d9132009-09-26 16:43:17 +000066GMP_DIR="gmp-${GMP_VERSION}"
67MPFR_DIR="mpfr-${MPFR_VERSION}"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000068MPC_DIR="mpc-${MPC_VERSION}"
69LIBELF_DIR="libelf-${LIBELF_VERSION}"
Stefan Reinauer074d9132009-09-26 16:43:17 +000070GCC_DIR="gcc-${GCC_VERSION}"
71BINUTILS_DIR="binutils-${BINUTILS_VERSION}"
72GDB_DIR="gdb-${GDB_VERSION}"
Marc Jones2aac3f62011-08-08 16:07:50 -060073IASL_DIR="acpica-unix-${IASL_VERSION}"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010074PYTHON_DIR="Python-${PYTHON_VERSION}"
75EXPAT_DIR="expat-${EXPAT_VERSION}"
Stefan Reinauer14ce2132015-06-05 13:01:13 -070076# CLANG toolchain directories
77LLVM_DIR="llvm-${CLANG_VERSION}.src"
78CFE_DIR="cfe-${CLANG_VERSION}.src"
79CRT_DIR="compiler-rt-${CLANG_VERSION}.src"
80CTE_DIR="clang-tools-extra-${CLANG_VERSION}.src"
Stefan Reinauer074d9132009-09-26 16:43:17 +000081
Patrick Georgi6321f522015-02-27 23:36:26 +010082unset MAKELEVEL MAKEFLAGS
83
Stefan Reinauer074d9132009-09-26 16:43:17 +000084SAVETEMPS=0
Stefan Reinauer14ce2132015-06-05 13:01:13 -070085BUILDCLANG=0
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010086SKIPGDB=1
87SKIPPYTHON=1
Stefan Reinauer074d9132009-09-26 16:43:17 +000088
Patrick Georgi1861ff72011-10-31 12:15:55 +010089red='\033[0;31m'
90RED='\033[1;31m'
91green='\033[0;32m'
92GREEN='\033[1;32m'
93blue='\033[0;34m'
94BLUE='\033[1;34m'
95cyan='\033[0;36m'
96CYAN='\033[1;36m'
97NC='\033[0m' # No Color
Stefan Reinauer074d9132009-09-26 16:43:17 +000098
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070099UNAME=`uname`
100
Patrick Georgi198d23c2012-12-08 08:02:44 +0100101normalize_dirs()
102{
103 mkdir -p $DESTDIR$TARGETDIR/lib
104 test -d $DESTDIR$TARGETDIR/lib32 && mv $DESTDIR$TARGETDIR/lib32/* $DESTDIR$TARGETDIR/lib
105 test -d $DESTDIR$TARGETDIR/lib64 && mv $DESTDIR$TARGETDIR/lib64/* $DESTDIR$TARGETDIR/lib
106 rmdir -p $DESTDIR$TARGETDIR/lib32 $DESTDIR$TARGETDIR/lib64
107
108 perl -pi -e "s,/lib32,/lib," $DESTDIR$TARGETDIR/lib/*.la
109 perl -pi -e "s,/lib64,/lib," $DESTDIR$TARGETDIR/lib/*.la
110}
111
Patrick Georgib7062882015-02-24 10:52:14 +0100112searchtool()
Stefan Reinauer074d9132009-09-26 16:43:17 +0000113{
114 # $1 short name
Patrick Georgib7062882015-02-24 10:52:14 +0100115 # $2 search string
116 # $3 soft fail if set
117 # result: file name of that tool on stdout
118 # or no output if nothing suitable was found
119 search=GNU
120 if [ -n "$2" ]; then
121 search="$2"
122 fi
Stefan Reinauer074d9132009-09-26 16:43:17 +0000123 for i in "$1" "g$1" "gnu$1"; do
124 if test -x "`which $i 2>/dev/null`"; then
Alexander Couzensd268ab32015-04-13 17:15:12 +0200125 if test `cat /dev/null | $i --version 2>&1 |grep -c "$search"` \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100126 -gt 0; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000127 echo $i
128 return
129 fi
130 fi
131 done
Andrew Wub67e9a12014-04-28 18:13:44 +0800132 # A workaround for OSX 10.9 and some BSDs, whose nongnu
133 # patch and tar also work.
Patrick Georgi7cb26b42015-04-28 21:29:22 +0200134 if [ $UNAME = "Darwin" -o $UNAME = "FreeBSD" -o $UNAME = "NetBSD" -o $UNAME = "OpenBSD" ]; then
Patrick Georgib7062882015-02-24 10:52:14 +0100135 if [ "$1" = "patch" -o "$1" = "tar" ]; then
Zheng Bao36156ff2012-09-28 16:18:58 +0800136 if test -x "`which $1 2>/dev/null`"; then
137 echo $1
138 return
139 fi
140 fi
141 fi
zbao939dc842015-04-30 04:44:07 +0800142 if [ "`echo $1 | cut -b -3`" = "sha" ]; then
143 if [ $UNAME = "FreeBSD" ]; then
144 if test -x "`which sha1 2>/dev/null`"; then
145 echo sha1
146 return
147 fi
148 fi
149 if [ $UNAME = "NetBSD" ]; then
150 if test -x "`which cksum 2>/dev/null`"; then
151 echo cksum -a `echo $1 | sed -e 's,sum,,'`
152 return
153 fi
154 fi
155 if [ $UNAME = "Darwin" ]; then
156 if test -x "`which openssl 2>/dev/null`"; then
157 echo openssl `echo $1 | sed -e 's,sum,,'`
158 return
159 fi
160 fi
161 fi
Patrick Georgiae5ab602015-04-29 23:30:15 +0200162 printf "${RED}ERROR:${red} Missing tool: Please install $1 (eg using your OS packaging system)${NC}\n" >&2
Patrick Georgib7062882015-02-24 10:52:14 +0100163 [ -z "$3" ] && exit 1
164 false
Stefan Reinauer074d9132009-09-26 16:43:17 +0000165}
166
Patrick Georgib7062882015-02-24 10:52:14 +0100167TAR=`searchtool tar` || exit $?
168PATCH=`searchtool patch` || exit $?
169MAKE=`searchtool make` || exit $?
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700170CMAKE=`searchtool cmake "cmake"` || exit $?
Stefan Reinauer699ac272015-06-05 12:43:28 -0700171SHA1SUM=`searchtool sha1sum`
172SHA512SUM=`searchtool sha512sum`
173CHECKSUM=$SHA1SUM
Stefan Reinauer074d9132009-09-26 16:43:17 +0000174
Patrick Georgib7062882015-02-24 10:52:14 +0100175searchtool m4 > /dev/null
176searchtool bison > /dev/null
177searchtool flex flex > /dev/null
178searchtool g++ "Free Software Foundation" nofail > /dev/null || \
Patrick Georgi915c4fc2015-03-09 13:58:23 +0100179searchtool clang "clang version" > /dev/null
180searchtool wget > /dev/null
181searchtool bzip2 "bzip2," > /dev/null
Patrick Georgi5fb2b5c2012-05-12 23:25:23 +0200182
Stefan Reinauer88935482015-06-05 09:51:10 -0700183download() {
Stefan Reinauer699ac272015-06-05 12:43:28 -0700184 PACKAGE=$1
185 archive=$PACKAGE"_ARCHIVE"
186 archive="`eval echo '$'$archive`"
187
188 FILE=`basename $archive`
Stefan Reinauer88935482015-06-05 09:51:10 -0700189 printf " * $FILE "
190
191 test -f tarballs/$FILE && \
192 (test -z "$CHECKSUM" || \
193 test "`cat sum/$FILE.cksum 2>/dev/null | sed -e 's,.*\([0-9a-f]\{40\}\).*,\1,'`" = "`$CHECKSUM tarballs/$FILE 2>/dev/null | sed -e 's,.*\([0-9a-f]\{40\}\).*,\1,'`" ) && \
194 printf "(cached)" || (
195 printf "(downloading)"
196 rm -f tarballs/$FILE
197 cd tarballs
Stefan Reinauer699ac272015-06-05 12:43:28 -0700198 wget --no-check-certificate -q $archive
Stefan Reinauer88935482015-06-05 09:51:10 -0700199 cd ..
200 test ! -f sum/$FILE.cksum && test -f tarballs/$FILE && \
201 (test -z "$CHECKSUM" || $CHECKSUM tarballs/$FILE > sum/$FILE.cksum ) && \
202 printf "(checksum created. ${RED}Note. Please upload sum/$FILE.cksum if the corresponding archive is upgraded.${NC})"
203 )
204 test -f tarballs/$FILE || \
205 printf "\n${RED}Failed to download $FILE.${NC}\n"
206 test -f tarballs/$FILE || exit 1
207 printf "\n"
208}
209
210unpack_and_patch() {
211 PACKAGE=$1
212 archive=$PACKAGE"_ARCHIVE"
213 archive="`eval echo '$'$archive`"
214 dir=$PACKAGE"_DIR"
215 dir="`eval echo '$'${dir}`"
216 test -d ${dir} && test -f ${dir}/.unpack_success || (
217 printf " * `basename $archive`\n"
218 FLAGS=zxf
219 suffix=`echo $archive | sed 's,.*\.,,'`
220 test "$suffix" = "gz" && FLAGS=zxf
221 test "$suffix" = "bz2" && FLAGS=jxf
222 test "$suffix" = "xz" && FLAGS="--xz -xf"
223 test "$suffix" = "lzma" && FLAGS="--lzma -xf"
224 $TAR $FLAGS tarballs/`basename $archive`
225 for patch in patches/${dir}_*.patch; do
226 test -r $patch || continue
227 printf " o `basename $patch`\n"
228 $PATCH -s -N -p0 < `echo $patch` || \
229 printf "\n${RED}Failed $patch.${NC}\n"
230 done
231 touch ${dir}/.unpack_success
232 )
233}
234
Patrick Georgi74c06422015-03-25 18:40:13 +0100235wait_for_build() {
236 # $1: directory in which log file and failure marker are stored
237 cat > "$1/crossgcc-build.log"
238 test -r "$1/.failed" && printf "${RED}failed${NC}. Check $1/crossgcc-build.log.\n" || \
239 printf "${green}ok${NC}\n"
240 test -r "$1/.failed" && exit 1
241 true
242}
243
Stefan Reinauer074d9132009-09-26 16:43:17 +0000244cleanup()
245{
246 printf "Cleaning up temporary files... "
Stefan Reinauer699ac272015-06-05 12:43:28 -0700247 # GCC toolchain
248 rm -rf ${GMP_DIR} ${BUILDDIRPREFIX}-gmp
249 rm -rf ${MPFR_DIR} ${BUILDDIRPREFIX}-mpfr
250 rm -rf ${MPC_DIR} ${BUILDDIRPREFIX}-mpc
251 rm -rf ${LIBELF_DIR} ${BUILDDIRPREFIX}-libelf
252 rm -rf ${BINUTILS_DIR} ${BUILDDIRPREFIX}-binutils
253 rm -rf ${GCC_DIR} ${BUILDDIRPREFIX}-gcc
254
255 # Other tools
256 rm -rf ${GDB_DIR} ${BUILDDIRPREFIX}-gdb
257 rm -rf ${EXPAT_DIR} ${BUILDDIRPREFIX}-expat
258 rm -rf ${PYTHON_DIR} ${BUILDDIRPREFIX}-python
259 rm -rf ${IASL_DIR}
260
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700261 # CLANG
262 rm -rf ${LLVM_DIR} ${CFE_DIR} ${CRT_DIR} ${CTE_DIR} ${BUILDDIR}
263
Stefan Reinauer074d9132009-09-26 16:43:17 +0000264 printf "${green}ok${NC}\n"
265}
266
267myhelp()
268{
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700269 printf "Usage: $0 [-V] [-c] [-p <platform>] [-d <target directory>] [-D <dest dir>] [-C] [-G] [-S]\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000270 printf " $0 [-V|--version]\n"
271 printf " $0 [-h|--help]\n\n"
272
273 printf "Options:\n"
274 printf " [-V|--version] print version number and exit\n"
275 printf " [-h|--help] print this help and exit\n"
276 printf " [-c|--clean] remove temporary files before build\n"
277 printf " [-t|--savetemps] don't remove temporary files after build\n"
Patrick Georgic1a75b12011-11-04 21:37:14 +0100278 printf " [-y|--ccache] Use ccache when building cross compiler\n"
Patrick Georgi73166c72010-04-14 20:42:42 +0000279 printf " [-j|--jobs <num>] run <num> jobs in parallel in make\n"
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700280 printf " [-C|--clang] build CLANG toolchain"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000281 printf " [-p|--platform <platform>] target platform to build cross compiler for\n"
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700282 printf " (defaults to $TARGETARCH) *)\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000283 printf " [-d|--directory <target dir>] target directory to install cross compiler to\n"
284 printf " (defaults to $TARGETDIR)\n\n"
285 printf " [-D|--destdir <dest dir>] destination directory to install cross compiler to\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100286 printf " (for RPM builds, default unset)\n"
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700287 printf " [-G|--gdb] build GNU debugger *)\n"
288 printf " [-S|--scripting] build scripting support for GDB *)\n\n"
289 printf " *) option only available when building GCC toolchain (not with CLANG)\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000290}
291
292myversion()
293{
294 # version tag is always printed, so just print the license here
295
296 cat << EOF
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000297Copyright (C) 2008-2010 by coresystems GmbH
Marc Jones2aac3f62011-08-08 16:07:50 -0600298Copyright (C) 2011 by Sage Electronic Engineering
Stefan Reinauer074d9132009-09-26 16:43:17 +0000299
300This program is free software; you can redistribute it and/or modify
301it under the terms of the GNU General Public License as published by
302the Free Software Foundation; version 2 of the License.
303
304This program is distributed in the hope that it will be useful,
305but WITHOUT ANY WARRANTY; without even the implied warranty of
306MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
307GNU General Public License for more details.
308
309EOF
310}
311
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700312printf "${blue}Welcome to the ${red}coreboot${blue} cross toolchain builder v$CROSSGCC_VERSION ($CROSSGCC_DATE)${NC}\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000313
Patrick Georgi6bba29f2010-01-29 17:40:52 +0000314# Look if we have getopt. If not, build it.
315export PATH=$PATH:.
316getopt - > /dev/null 2>/dev/null || gcc -o getopt getopt.c
317
Stefan Reinauer074d9132009-09-26 16:43:17 +0000318# parse parameters.. try to find out whether we're running GNU getopt
Peter Stuge09377b72011-08-21 06:24:55 +0200319getoptbrand="`getopt -V | sed -e '1!d' -e 's,^\(......\).*,\1,'`"
320if [ "${getoptbrand}" = "getopt" ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000321 # Detected GNU getopt that supports long options.
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700322 args=`getopt -l version,help,clean,directory:,platform:,jobs:,destdir:,savetemps,skip-gdb,ccache,clang Vhcd:p:j:D:tGyC -- "$@"`
Stefan Reinauer074d9132009-09-26 16:43:17 +0000323 eval set "$args"
324else
325 # Detected non-GNU getopt
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700326 args=`getopt Vhcd:p:j:D:tGyC $*`
Stefan Reinauer074d9132009-09-26 16:43:17 +0000327 set -- $args
328fi
329
330if [ $? != 0 ]; then
331 myhelp
332 exit 1
333fi
334
335while true ; do
336 case "$1" in
337 -V|--version) shift; myversion; exit 0;;
338 -h|--help) shift; myhelp; exit 0;;
Patrick Georgi44af57a2013-12-19 22:06:22 +0100339 -c|--clean) shift; clean=1;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000340 -t|--savetemps) shift; SAVETEMPS=1;;
341 -d|--directory) shift; TARGETDIR="$1"; shift;;
342 -p|--platform) shift; TARGETARCH="$1"; shift;;
343 -D|--destdir) shift; DESTDIR="$1"; shift;;
Patrick Georgi73166c72010-04-14 20:42:42 +0000344 -j|--jobs) shift; JOBS="-j $1"; shift;;
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700345 -C|--clang) shift; BUILDCLANG=1;;
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100346 -G|--gdb) shift; SKIPGDB=0;;
347 -S|--scripting) shift; SKIPPYTHON=0;;
Patrick Georgic1a75b12011-11-04 21:37:14 +0100348 -y|--ccache) shift; USECCACHE=1;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200349 --) shift; break;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000350 -*) printf "Invalid option\n\n"; myhelp; exit 1;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200351 *) break;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000352 esac
353done
354
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700355case "$TARGETARCH" in
Stefan Reinauer24f9cb92015-03-13 22:50:22 +0100356 x86_64-elf) ;;
357 x86_64*) TARGETARCH=x86_64-elf;;
David Hubbard5b0420a2013-05-28 16:33:15 -0600358 i386-elf) ;;
359 i386-mingw32) ;;
Patrick Georgi9b7efa52015-03-08 09:20:36 +0100360 mipsel-elf) ;;
Patrick Georgif0bbc952015-03-07 10:57:25 +0100361 riscv-elf) ;;
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700362 i386*) TARGETARCH=i386-elf;;
Patrick Georgic8883262013-09-19 10:57:58 +0200363 arm*) TARGETARCH=armv7-a-eabi;;
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700364 aarch64*) TARGETARCH=aarch64-elf;;
365 *) printf "${red}WARNING: Unsupported architecture $TARGETARCH.${NC}\n\n"; ;;
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700366esac
367
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700368if [ "$BUILDCLANG" -eq 0 ]; then
369echo "Target architecture is now $TARGETARCH"
Stefan Reinauer699ac272015-06-05 12:43:28 -0700370NAME="${TARGETARCH} cross"
371PACKAGES="GMP MPFR MPC LIBELF BINUTILS GCC IASL"
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700372else
373NAME=clang
374PACKAGES="LLVM CFE CRT CTE"
375fi
Stefan Reinauer699ac272015-06-05 12:43:28 -0700376
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200377BUILDDIRPREFIX=build-${TARGETARCH}
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700378BUILDDIR=$PWD/build-clang
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200379
Patrick Georgi44af57a2013-12-19 22:06:22 +0100380if [ "$clean" = "1" ]; then
381 cleanup
382fi
383
Peter Stugeceacd772011-06-09 04:54:16 +0200384if [ $SKIPGDB -eq 1 ]; then
385 printf "Will skip GDB ... ${green}ok${NC}\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100386 if [ $SKIPPYTHON -eq 0 ]; then
387 printf "Python scripting needs GDB ... disabling ... ${green}ok${NC}\n"
388 SKIPPYTHON=1
389 fi
Stefan Reinauer699ac272015-06-05 12:43:28 -0700390else
391 PACKAGES="$PACKAGES GDB"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100392fi
Stefan Reinauer699ac272015-06-05 12:43:28 -0700393if [ $SKIPPYTHON -eq 0 ]; then
394 PACKAGES="$PACKAGES EXPAT PYTHON"
Peter Stugeceacd772011-06-09 04:54:16 +0200395fi
396
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700397# coreboot does not like the GOLD linker
398# USE_GOLD="--enable-gold"
399USE_GOLD=""
400GCC_OPTIONS="--enable-lto"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000401
Stefan Reinauer074d9132009-09-26 16:43:17 +0000402printf "Downloading tar balls ... \n"
403mkdir -p tarballs
Stefan Reinauer699ac272015-06-05 12:43:28 -0700404for P in $PACKAGES; do
405 download $P
Stefan Reinauer074d9132009-09-26 16:43:17 +0000406done
Stefan Reinauer699ac272015-06-05 12:43:28 -0700407printf "Downloaded tar balls ... ${green}ok${NC}\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000408
409printf "Unpacking and patching ... \n"
Stefan Reinauer699ac272015-06-05 12:43:28 -0700410for P in $PACKAGES; do
411 unpack_and_patch $P
Stefan Reinauer074d9132009-09-26 16:43:17 +0000412done
Stefan Reinauer699ac272015-06-05 12:43:28 -0700413printf "Unpacked and patched ... ${green}ok${NC}\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000414
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700415if [[ "$PACKAGES" == *GCC* ]]; then
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700416CC=cc
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700417if [ $UNAME = "Darwin" ]; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000418 #GCC_OPTIONS="$GCC_OPTIONS --enable-threads=posix"
419
420 # generally the OS X compiler can create x64 binaries.
421 # Per default it generated i386 binaries in 10.5 and x64
422 # binaries in 10.6 (even if the kernel is 32bit)
423 # For some weird reason, 10.5 autodetects an ABI=64 though
424 # so we're setting the ABI explicitly here.
Zheng Bao04ceed62012-10-23 19:41:25 +0800425 if [ `sysctl -n hw.optional.x86_64 2>/dev/null` -eq 1 ] 2>/dev/null; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000426 OPTIONS="ABI=64"
427 else
428 OPTIONS="ABI=32"
429 fi
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700430
Stefan Reinauer4266b922012-12-05 16:18:32 -0800431 # In Xcode 4.5.2 the default compiler is clang.
432 # However, this compiler fails to compile gcc 4.7.x. As a
433 # workaround it's possible to compile gcc with llvm-gcc.
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700434 if $CC -v 2>&1 | grep -q LLVM; then
Stefan Reinauer4266b922012-12-05 16:18:32 -0800435 CC=llvm-gcc
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700436 fi
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000437fi
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700438fi # GCC
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000439
Patrick Georgic1a75b12011-11-04 21:37:14 +0100440if [ "$USECCACHE" = 1 ]; then
441 CC="ccache $CC"
442fi
443
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200444mkdir -p ${BUILDDIRPREFIX}-gmp ${BUILDDIRPREFIX}-mpfr ${BUILDDIRPREFIX}-mpc ${BUILDDIRPREFIX}-libelf ${BUILDDIRPREFIX}-binutils \
Stefan Reinauer699ac272015-06-05 12:43:28 -0700445 ${BUILDDIRPREFIX}-gcc ${BUILDDIRPREFIX}-python ${BUILDDIRPREFIX}-expat ${BUILDDIRPREFIX}-gdb
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700446mkdir -p ${BUILDDIR}
Stefan Reinauer16bd7892012-12-07 23:57:01 +0100447
448mkdir -p $DESTDIR$TARGETDIR/bin
449export PATH=$DESTDIR$TARGETDIR/bin:$PATH
450
Stefan Reinauer699ac272015-06-05 12:43:28 -0700451[[ "$PACKAGES" == *GMP* ]] && \
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200452if [ -f ${BUILDDIRPREFIX}-gmp/.success ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000453 printf "Skipping GMP as it is already built\n"
454else
Stefan Reinauer699ac272015-06-05 12:43:28 -0700455 printf "Building GMP ${GMP_VERSION} ... "
Stefan Reinauer074d9132009-09-26 16:43:17 +0000456(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200457 cd ${BUILDDIRPREFIX}-gmp
Stefan Reinauer074d9132009-09-26 16:43:17 +0000458 rm -f .failed
Patrick Georgi31bf37e2015-06-04 00:09:12 +0200459 CC="$CC" CFLAGS="-Os" ../${GMP_DIR}/configure --disable-shared --enable-fat --prefix=$TARGETDIR $OPTIONS \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000460 || touch .failed
Patrick Georgi73166c72010-04-14 20:42:42 +0000461 $MAKE $JOBS || touch .failed
Stefan Reinauer074d9132009-09-26 16:43:17 +0000462 $MAKE install DESTDIR=$DESTDIR || touch .failed
Patrick Georgi198d23c2012-12-08 08:02:44 +0100463
464 normalize_dirs
465
Stefan Reinauer074d9132009-09-26 16:43:17 +0000466 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi74c06422015-03-25 18:40:13 +0100467) 2>&1 | wait_for_build "${BUILDDIRPREFIX}-gmp" || exit 1
Stefan Reinauer074d9132009-09-26 16:43:17 +0000468
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700469# Now set CFLAGS to match GMP CFLAGS but strip out -pedantic
470# as GCC 4.6.x fails if it's there.
471HOSTCFLAGS=`grep __GMP_CFLAGS $DESTDIR$TARGETDIR/include/gmp.h |cut -d\" -f2 |\
472 sed s,-pedantic,,`
Stefan Reinauer699ac272015-06-05 12:43:28 -0700473fi
Stefan Reinauer074d9132009-09-26 16:43:17 +0000474
Stefan Reinauer699ac272015-06-05 12:43:28 -0700475[[ "$PACKAGES" == *MPFR* ]] && \
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200476if [ -f ${BUILDDIRPREFIX}-mpfr/.success ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000477 printf "Skipping MPFR as it is already built\n"
478else
Stefan Reinauer699ac272015-06-05 12:43:28 -0700479 printf "Building MPFR ${MPFR_VERSION} ... "
Stefan Reinauer074d9132009-09-26 16:43:17 +0000480(
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700481 test $UNAME = "Darwin" && CFLAGS="$CFLAGS -force_cpusubtype_ALL"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200482 cd ${BUILDDIRPREFIX}-mpfr
Stefan Reinauer074d9132009-09-26 16:43:17 +0000483 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100484 CC="$CC" ../${MPFR_DIR}/configure --disable-shared --prefix=$TARGETDIR \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000485 --infodir=$TARGETDIR/info \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100486 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
487 touch .failed
Patrick Georgi73166c72010-04-14 20:42:42 +0000488 $MAKE $JOBS || touch .failed
Stefan Reinauer074d9132009-09-26 16:43:17 +0000489 $MAKE install DESTDIR=$DESTDIR || touch .failed
490
Patrick Georgi198d23c2012-12-08 08:02:44 +0100491 normalize_dirs
492
Stefan Reinauer074d9132009-09-26 16:43:17 +0000493 # work around build problem of libgmp.la
494 if [ "$DESTDIR" != "" ]; then
495 perl -pi -e "s,$DESTDIR,," $DESTDIR$TARGETDIR/libgmp.la
496 fi
497
498 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi74c06422015-03-25 18:40:13 +0100499) 2>&1 | wait_for_build "${BUILDDIRPREFIX}-mpfr" || exit 1
Stefan Reinauer074d9132009-09-26 16:43:17 +0000500fi
501
Stefan Reinauer699ac272015-06-05 12:43:28 -0700502[[ "$PACKAGES" == *MPC* ]] && \
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200503if [ -f ${BUILDDIRPREFIX}-mpc/.success ]; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000504 printf "Skipping MPC as it is already built\n"
505else
Stefan Reinauer699ac272015-06-05 12:43:28 -0700506 printf "Building MPC ${MPC_VERSION} ... "
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000507(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200508 cd ${BUILDDIRPREFIX}-mpc
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000509 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100510 CC="$CC" ../${MPC_DIR}/configure --disable-shared --prefix=$TARGETDIR \
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000511 --infodir=$TARGETDIR/info --with-mpfr=$DESTDIR$TARGETDIR \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100512 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
513 touch .failed
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000514 $MAKE $JOBS || touch .failed
515 $MAKE install DESTDIR=$DESTDIR || touch .failed
516
Patrick Georgi198d23c2012-12-08 08:02:44 +0100517 normalize_dirs
518
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000519 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi74c06422015-03-25 18:40:13 +0100520) 2>&1 | wait_for_build "${BUILDDIRPREFIX}-mpc" || exit 1
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000521fi
522
Stefan Reinauer699ac272015-06-05 12:43:28 -0700523[[ "$PACKAGES" == *LIBELF* ]] && \
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200524if [ -f ${BUILDDIRPREFIX}-libelf/.success ]; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000525 printf "Skipping libelf as it is already built\n"
526else
Stefan Reinauer699ac272015-06-05 12:43:28 -0700527 printf "Building libelf ${LIBELF_VERSION} ... "
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000528(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200529 cd ${BUILDDIRPREFIX}-libelf
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000530 rm -f .failed
531 echo "$HOSTCFLAGS"
Patrick Georgi643c9e82011-11-04 21:30:49 +0100532 CC="$CC" CFLAGS="$HOSTCFLAGS" libelf_cv_elf_h_works=no \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100533 ../${LIBELF_DIR}/configure --disable-shared --prefix=$TARGETDIR \
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000534 --infodir=$TARGETDIR/info CFLAGS="$HOSTCFLAGS" || touch .failed
535 $MAKE $JOBS || touch .failed
Scott Duplichan4270a972014-12-12 20:21:40 -0600536 $MAKE install prefix=$DESTDIR$TARGETDIR || touch .failed
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000537
Patrick Georgi198d23c2012-12-08 08:02:44 +0100538 normalize_dirs
539
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000540 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi74c06422015-03-25 18:40:13 +0100541) 2>&1 | wait_for_build "${BUILDDIRPREFIX}-libelf" || exit 1
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000542fi
543
Stefan Reinauer699ac272015-06-05 12:43:28 -0700544[[ "$PACKAGES" == *BINUTILS* ]] && \
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200545if [ -f ${BUILDDIRPREFIX}-binutils/.success ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000546 printf "Skipping binutils as it is already built\n"
547else
Stefan Reinauer699ac272015-06-05 12:43:28 -0700548 printf "Building binutils ${BINUTILS_VERSION} ... "
Stefan Reinauer074d9132009-09-26 16:43:17 +0000549(
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700550 # What a pain: binutils don't come with configure
551 # script anymore. Create it:
552 cd binutils-${BINUTILS_VERSION}/
553 autoconf
554 cd ..
555 # Now build binutils
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200556 cd ${BUILDDIRPREFIX}-binutils
Stefan Reinauer074d9132009-09-26 16:43:17 +0000557 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100558 CC="$CC" ../binutils-${BINUTILS_VERSION}/configure --prefix=$TARGETDIR \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100559 --target=${TARGETARCH} --disable-werror --disable-nls \
560 $USE_GOLD CFLAGS="$HOSTCFLAGS" || touch .failed
Patrick Georgi73166c72010-04-14 20:42:42 +0000561 $MAKE $JOBS || touch .failed
Stefan Reinauer074d9132009-09-26 16:43:17 +0000562 $MAKE install DESTDIR=$DESTDIR || touch .failed
563 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi74c06422015-03-25 18:40:13 +0100564) 2>&1 | wait_for_build "${BUILDDIRPREFIX}-binutils" || exit 1
Stefan Reinauer074d9132009-09-26 16:43:17 +0000565fi
566
Stefan Reinauer699ac272015-06-05 12:43:28 -0700567[[ "$PACKAGES" == *GCC* ]] && \
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200568if [ -f ${BUILDDIRPREFIX}-gcc/.success ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000569 printf "Skipping GCC as it is already built\n"
570else
Stefan Reinauer699ac272015-06-05 12:43:28 -0700571 printf "Building GCC ${GCC_VERSION} ... "
Stefan Reinauer074d9132009-09-26 16:43:17 +0000572(
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700573 # Even worse than binutils: GCC does not come with configure
574 # script anymore, but also enforces an obsolete autoconf version
575 # to create it. This is a poster child of how autotools help make
576 # software portable.
577 cd gcc-${GCC_VERSION}
578 sed '/dnl Ensure exactly this Autoconf version is used/d' \
579 config/override.m4 > config/override.m4.new
580 autoconf_version=`autoconf -V | grep "autoconf" | tr ' ' '\n' | tail -1`
581 sed "s/${GCC_AUTOCONF_VERSION}/${autoconf_version}/g" \
582 config/override.m4.new > config/override.m4
583 autoconf
584 cd ..
585 # Now, finally, we can build gcc:
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200586 cd ${BUILDDIRPREFIX}-gcc
Stefan Reinauer074d9132009-09-26 16:43:17 +0000587 rm -f .failed
588 # GCC does not honour HOSTCFLAGS at all. CFLAGS are used for
589 # both target and host object files. This is pretty misdesigned.
590 # There's a work-around called CFLAGS_FOR_BUILD and CFLAGS_FOR_TARGET
591 # but it does not seem to work properly. At least the host library
592 # libiberty is not compiled with CFLAGS_FOR_BUILD.
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700593 CC="$CC" CFLAGS_FOR_TARGET="-O2" CFLAGS="$HOSTCFLAGS" \
594 CFLAGS_FOR_BUILD="$HOSTCFLAGS" ../gcc-${GCC_VERSION}/configure \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000595 --prefix=$TARGETDIR --libexecdir=$TARGETDIR/lib \
Stefan Reinauer6ade1612010-01-16 16:44:20 +0000596 --target=${TARGETARCH} --disable-werror --disable-shared \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000597 --disable-libssp --disable-bootstrap --disable-nls \
Patrick Georgi969cd932012-12-07 13:13:53 +0100598 --disable-libquadmath --without-headers \
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000599 $GCC_OPTIONS --enable-languages="c" $USE_GOLD \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000600 --with-gmp=$DESTDIR$TARGETDIR --with-mpfr=$DESTDIR$TARGETDIR \
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000601 --with-mpc=$DESTDIR$TARGETDIR --with-libelf=$DESTDIR$TARGETDIR \
602 --with-pkgversion="coreboot toolchain v$CROSSGCC_VERSION $CROSSGCC_DATE" \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000603 || touch .failed
Patrick Georgi969cd932012-12-07 13:13:53 +0100604 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-gcc || touch .failed
605 $MAKE install-gcc DESTDIR=$DESTDIR || touch .failed
606
607 if [ "`echo $TARGETARCH | grep -c -- -mingw32`" -eq 0 ]; then
608 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-target-libgcc || touch .failed
609 $MAKE install-target-libgcc DESTDIR=$DESTDIR || touch .failed
610 fi
611
Stefan Reinauer074d9132009-09-26 16:43:17 +0000612 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi74c06422015-03-25 18:40:13 +0100613) 2>&1 | wait_for_build "${BUILDDIRPREFIX}-gcc" || exit 1
Stefan Reinauer074d9132009-09-26 16:43:17 +0000614fi
615
Stefan Reinauer699ac272015-06-05 12:43:28 -0700616[[ "$PACKAGES" == *EXPAT* ]] && \
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200617if [ -f ${BUILDDIRPREFIX}-expat/.success ]; then
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100618 printf "Skipping Expat as it is already built\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100619else
Stefan Reinauer699ac272015-06-05 12:43:28 -0700620 printf "Building Expat ${EXPAT_VERSION} ... "
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100621(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200622 cd ${BUILDDIRPREFIX}-expat
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100623 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100624 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${EXPAT_DIR}/configure --disable-shared \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100625 --prefix=$TARGETDIR --target=${TARGETARCH} || touch .failed
626 $MAKE || touch .failed
627 $MAKE install DESTDIR=$DESTDIR || touch .failed
Patrick Georgi198d23c2012-12-08 08:02:44 +0100628
629 normalize_dirs
630
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100631 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi74c06422015-03-25 18:40:13 +0100632) 2>&1 | wait_for_build "${BUILDDIRPREFIX}-expat" || exit 1
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100633fi
634
Stefan Reinauer699ac272015-06-05 12:43:28 -0700635[[ "$PACKAGES" == *PYTHON* ]] && \
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200636if [ -f ${BUILDDIRPREFIX}-python/.success ]; then
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100637 printf "Skipping Python as it is already built\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100638else
Stefan Reinauer699ac272015-06-05 12:43:28 -0700639 printf "Building Python ${PYTHON_VERSION} ... "
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100640(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200641 cd ${BUILDDIRPREFIX}-python
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100642 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100643 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${PYTHON_DIR}/configure --prefix=$TARGETDIR \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100644 --target=${TARGETARCH} || touch .failed
645 $MAKE $JOBS || touch .failed
646 $MAKE install DESTDIR=$DESTDIR || touch .failed
Patrick Georgi198d23c2012-12-08 08:02:44 +0100647
648 normalize_dirs
649
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100650 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi74c06422015-03-25 18:40:13 +0100651) 2>&1 | wait_for_build "${BUILDDIRPREFIX}-python" || exit 1
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100652fi
653
Stefan Reinauer699ac272015-06-05 12:43:28 -0700654[[ "$PACKAGES" == *GDB* ]] && \
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200655if [ -f ${BUILDDIRPREFIX}-gdb/.success ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000656 printf "Skipping GDB as it is already built\n"
657else
Stefan Reinauer699ac272015-06-05 12:43:28 -0700658 printf "Building GDB ${GDB_VERSION} ... "
Stefan Reinauer074d9132009-09-26 16:43:17 +0000659(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200660 cd ${BUILDDIRPREFIX}-gdb
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100661 export PYTHONHOME=$DESTDIR$TARGETDIR
Stefan Reinauer074d9132009-09-26 16:43:17 +0000662 rm -f .failed
Idwer Vollering1b7c9592015-04-09 15:34:07 +0200663 if [ $(uname) != "FreeBSD" -a $(uname) != "NetBSD" ]; then
664 LIBDL="-ldl"
665 fi
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100666 LDFLAGS="-Wl,-rpath,\$\$ORIGIN/../lib/ -L$DESTDIR$TARGETDIR/lib \
Idwer Vollering1b7c9592015-04-09 15:34:07 +0200667 -lpthread $LIBDL -lutil" \
Patrick Georgi643c9e82011-11-04 21:30:49 +0100668 CC="$CC" CFLAGS="$HOSTCFLAGS -I$DESTDIR$TARGETDIR/include" \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100669 ../gdb-${GDB_VERSION}/configure --prefix=$TARGETDIR \
670 --target=${TARGETARCH} --disable-werror --disable-nls
Patrick Georgi73166c72010-04-14 20:42:42 +0000671 $MAKE $JOBS || touch .failed
Stefan Reinauer074d9132009-09-26 16:43:17 +0000672 $MAKE install DESTDIR=$DESTDIR || touch .failed
673 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi74c06422015-03-25 18:40:13 +0100674) 2>&1 | wait_for_build "${BUILDDIRPREFIX}-gdb" || exit 1
Stefan Reinauer074d9132009-09-26 16:43:17 +0000675fi
676
Stefan Reinauer699ac272015-06-05 12:43:28 -0700677[[ "$PACKAGES" == *IASL* ]] && \
Patrick Georgi6e61ad32012-05-12 23:19:30 +0200678if [ -f $IASL_DIR/source/compiler/.success ]; then
Marc Jones2aac3f62011-08-08 16:07:50 -0600679 printf "Skipping IASL as it is already built\n"
680else
Stefan Reinauer699ac272015-06-05 12:43:28 -0700681 printf "Building IASL ${IASL_VERSION} ... "
Marc Jones2aac3f62011-08-08 16:07:50 -0600682(
Patrick Georgi74c06422015-03-25 18:40:13 +0100683 RDIR=$IASL_DIR/source/compiler
Idwer Vollering6b11c8b2012-11-15 21:14:36 +0100684 cd $IASL_DIR/generate/unix
Patrick Georgi74c06422015-03-25 18:40:13 +0100685 rm -f $RDIR/.failed
Marc Jones2aac3f62011-08-08 16:07:50 -0600686 CFLAGS="$HOSTCFLAGS"
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700687 HOST="_LINUX"
688 test $UNAME = "Darwin" && HOST="_APPLE"
689 test $UNAME = "FreeBSD" && HOST="_FreeBSD"
690 test $UNAME = "Cygwin" && HOST="_CYGWIN"
Patrick Georgi74c06422015-03-25 18:40:13 +0100691 HOST="$HOST" OPT_CFLAGS="-O -D_FORTIFY_SOURCE=2" CFLAGS="$CFLAGS" $MAKE CC="$CC" iasl || touch $RDIR/.failed
692 rm -f $DESTDIR$TARGETDIR/bin/iasl || touch $RDIR/.failed
693 cp bin/iasl $DESTDIR$TARGETDIR/bin || touch $RDIR/.failed
694 if [ ! -f $RDIR/.failed ]; then touch $RDIR/.success; fi
695) 2>&1 | wait_for_build "$IASL_DIR/source/compiler" || exit 1
Marc Jones2aac3f62011-08-08 16:07:50 -0600696fi
697
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700698[[ "$PACKAGES" == *CLANG* ]] && \
699if [ -f ${BUILDDIR}/.success ]; then
700 printf "Skipping CLANG as it is already built\n"
701else
702 printf "Building CLANG ${CLANG_VERSION} ... "
703(
704 ln -sf $PWD/$CFE_DIR $LLVM_DIR/tools/clang
705 ln -sf $PWD/$CTE_DIR $LLVM_DIR/tools/clang/tools/extra
706 ln -sf $PWD/$CRT_DIR $LLVM_DIR/projects/compiler-rt
707
708 cd ${BUILDDIR}
709
710 $CMAKE -G "Unix Makefiles" -DCMAKE_INSTALL_PREFIX=$DESTDIR$TARGETDIR \
711 -DCMAKE_BUILD_TYPE=Release ../$LLVM_DIR || touch .failed
712 $MAKE $JOBS || touch .failed
713 $MAKE install || touch .failed
714
715 cd -
716
717 cp -a $CFE_DIR/tools/scan-build/* $DESTDIR$TARGETDIR/bin
718 cp -a $CFE_DIR/tools/scan-view/* $DESTDIR$TARGETDIR/bin
719
720 if [ ! -f .failed ]; then touch .success; fi
721) 2>&1 | wait_for_build "${BUILDDIR}" || exit 1
722fi
723
Stefan Reinauer699ac272015-06-05 12:43:28 -0700724# Adding git information of current tree to target directory
725# for reproducibility
Patrick Georgi5602f2c2015-03-28 15:48:47 +0100726PROGNAME=`basename "$0"`
727rm -f "$DESTDIR$TARGETDIR/$PROGNAME".commit.*
728cp "$PROGNAME" $DESTDIR$TARGETDIR/"$PROGNAME.commit.`git describe`"
Zheng Bao30b895f2013-02-06 18:04:40 +0800729
Stefan Reinauer074d9132009-09-26 16:43:17 +0000730if [ $SAVETEMPS -eq 0 ]; then
Stefan Reinauer699ac272015-06-05 12:43:28 -0700731 cleanup
Stefan Reinauer074d9132009-09-26 16:43:17 +0000732else
733 printf "Leaving temporary files around... ${green}ok${NC}\n"
734fi
735
Stefan Reinauer699ac272015-06-05 12:43:28 -0700736printf "\n${green}You can now run your $NAME toolchain from $TARGETDIR.${NC}\n"